; Random dataset generator. Needs STk scheme (available at
; /home/pram/STK311/stk/3.1.1/SunOS-5.5.1-sun4/stk at IDA) to work

(define (create-instances filename)
  (let ((output (open-output-file filename))
	(num-attributes 5)
	(num-instances 20)
	(num-classes 3)
	(value-range 6))
    (define (list-classes n)
      (if (> n 0)
	  (begin (display (- num-classes n) output)
		 (display "," output)
		 (list-classes (1- n)))))
    (define (preamble n)
      (cond ((= n 1)
	     (display "@attribute a" output)
	     (display (- num-attributes (- n 1)) output)
	     (display " {" output)
	     (list-classes num-classes)
	     (display "}\n\n@data\n" output))
	    (else     
	     (display "@attribute a" output)
	     (display (- num-attributes (- n 1)) output)
	     (display " real\n" output)
	     (preamble (- n 1)))))
    (define (create-row n)
      (cond ((= n 1) 
	     (display (random num-classes) output)
	     (newline output))
	    (else 
	     (display (random value-range) output)
	     (display "," output)
	     (create-row (1- n)))))
    (define (create-rows m)
      (cond ((= m 0)
	     (flush output)
	     (close-output-port output))
	    (else 
	     (create-row num-attributes)
	     (create-rows (1- m)))))
    (display "@relation test\n\n" output)
    (preamble num-attributes)
    (create-rows num-instances)))


