package weka.roughset;

import weka.core.*;
import java.io.*;
import java.util.*;

/* This must implement comparable to be sortable.. */

public class RoughInstance extends Instance implements Comparable {

  private RoughInstances dataSet;

  public RoughInstance(Instance i, RoughInstances r) {
     super(i);
     dataSet = r;
     this.setDataset(i.dataset());
  }

  public int compareTo(Object obj) {
    int comp = 0;
    RoughInstance i = (RoughInstance)obj;
    Attribute a;
    Iterator iter = getActiveAttributes().iterator();	   
    while ( iter.hasNext() && (comp == 0) ) {
      a = (Attribute)iter.next();
      double val1 = this.value(a),val2 = i.value(a);
      comp = ((Double.isNaN(val1)||Double.isNaN(val2)) 
	      && dataSet.missingIsWildcard() ? 
	      0 : (new Double(val1)).compareTo(new Double(val2)));
    } // end of while ()
    if ( comp == 0  && dataSet.isCompareDecision() ) {
      comp = (new Double(this.classValue())).
	compareTo(new Double(i.classValue()));
    } // end of if ()    
    return comp;       
  }

  /* Two Rough Instances are considered equal if they share the same
     values for attributes in the collection "activeAttributes" in the
     RoughInstances class */

  public boolean equals(Object obj){
    return 
      (obj != null) && 
      (obj instanceof RoughInstance) && 
      (compareTo(obj) == 0);
  }
  
  public RoughInstances roughDataSet() {
    return dataSet;
  }
  
  public void setRoughDataSet(RoughInstances v) {
    dataSet = v;
  }

  public Attributes getActiveAttributes(){
    return dataSet.getActiveAttributes();
  }
  
  public int hashCode() { 
    StringBuffer s = new StringBuffer();
    for (Iterator i=dataSet.getActiveAttributes().iterator();i.hasNext(); ) {
      s.append(value((Attribute)i.next())+(i.hasNext()?",":""));
    } // end of for ()
    if ( dataSet.isCompareDecision() ) {
      s.append(","+classValue());
    } // end of if ()
    return s.toString().hashCode();
  }

  public String toString() {
    StringBuffer s = new StringBuffer();
    int m = this.dataSet.numAttributes();
    for (int j = 0; j < m; j++) {
      s.append((isMissing(j) ? "?" : ""+value(j))+(j<m-1?",":"\n"));
    }
    return s.toString();
  }

  public static void main (String[] args) {
    


  } // end of main ()
  
}


